(define-method (open-item! self::file-item)
   (with-access::file-item self (data children parent)
      (if (null? children)
	  (for-each (lambda (x)
		       (let ((f (string-append data "/" x)))
			  (if (directory? f)
			      (add-node! parent self f)
			      (add-leave! parent self f))))
		    (directory->list data))))
   ;; Do the redisplay
   (call-next-method))

(define-method (label-item self::file-item)
   (let ((name (file-item-data self)))
      (if (string=? name "/")
	  "/"
	  (basename name))))

(define-method (select-item! self::file-item)
   (with-access::file-item self (data)
      (if (not (directory? data))
	  (system (string-append "xedit " data " &"))))
   (call-next-method))

(define T (instantiate::file-tree
	     (make-items (lambda (self ancestor data node? icon)
			    (instantiate::file-item
			       (parent self)
			       (ancestor ancestor)
			       (data data)
			       (node? node?)
			       (icon icon))))))

(pack T :expand #t :fill "both")
(add-node! T #f ".")
