
(define-method (open-item! self::inheritance-item)
   (with-access::inheritance-item self (data children parent)
      (let ((subclasses (class-subclasses data)))
	 (if (and (null? children) (not (null? subclasses)))
	     (for-each (lambda (x)
			  (if (null? (class-subclasses x))
			      (add-leave! parent self x)
			      (add-node! parent self x)))
		       subclasses))))
   (call-next-method))

(define-method (close-item! self::inheritance-item)
   (with-access::inheritance-item self (data children hierarchy)
      (set! children '()))
   (call-next-method))

(define-method (label-item self::hierarchy-item)
   (with-access::inheritance-item self (data)
      (class-name data)))

(define t (instantiate::inheritance-tree
	     (make-items (lambda (self ancestor data node? icon)
			    (instantiate::inheritance-item
			       (parent self)
			       (ancestor ancestor)
			       (data data)
			       (node? node?)
			       (icon icon))))))

(pack t :expand #t :fill 'both)

(add-node! t #f object)
