(define-macro (P x) ; A macro for printing traces (for this demo)
  `(lambda () (display ,x) (newline)))

(define st (instantiate::scrolltext))

(define f1
   (let ((toolbar (instantiate::toolbar
		     (background "gray")
		     (parent (top-level-root)))))
      (fill-toolbar! toolbar
		     `(("File"
			("---")			;; we want a tear-off
			("Open" 	,(P "Open"))
			("Close"	,(P "Close"))
			("")			;; insert a  separator
			("Exit"	,(lambda() (exit 0))))
		       ("Edit"
			("Cut" 	,(P "Cut"))
			("Copy"  ,(P "Copy"))
			("Paste" ,(P "Paste"))
			("Submenu" 		;; a submenu without tear-off
			 ("sub1"  ,(P "sub1"))
			 ("sub2"  ,(P "sub2")))
			;; a completely managed item
			(radiobutton :label "Foo" :foreground "blue3")
			(radiobutton :label "Bar" :foreground "blue3"))))))

(define f2
   (let ((toolbar (instantiate::toolbar
		     (parent (top-level-root))
		     (background "gray80"))))
      (fill-toolbar! toolbar
		     `(("console.gif" "Open New Console" 	    ,(P 1))
		       ("edit.gif"      "Open New Editor" 	    ,(P 2))
		       50
		       ("customize.gif" "Customize Environment" ,(P 3))
		       -50 		
		       ("diropen.gif"   "Load File"   	    ,(P 4))))))

(define f3 
   (let ((toolbar (instantiate::toolbar
		     (parent (top-level-root))
		     (background "gray60")
		     (orientation "vertical"))))
      (fill-toolbar! toolbar
		    `(("copy.gif"      "Copy" 	  ,(P 5))
		      ("clipboard.gif" "Paste"        ,(P 6))
		      ("cut.gif"       "Cut" 	  ,(P 7))
		      -20
		      ("qmark.gif" "Help on Console"  , (P 8))))))

(pack f1 f2 :side "top" :fill 'x)
(pack f3 :side "left" :fill 'y)
(pack st :fill 'both :expand #t :side "bottom")
