;*=====================================================================*/
;*    serrano/prgm/project/bglk/manual/manual.el                       */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Jan  7 11:07:45 1999                          */
;*    Last change :  Mon Jan 11 08:36:56 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    ELisp mode for edition biglook manual.                           */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    include option                                                   */
;*---------------------------------------------------------------------*/
(defun io (name)
  (interactive "sName: ")
  (insert-command (concat ":" name) name name (capitalize name)))

(defun fetch-word ()
  (if (re-search-forward "[ ]*\\([^ \n]+\\)")
      (progn
	(let ((word (buffer-substring (match-beginning 1) (match-end 1))))
	  (delete-region (match-beginning 0) (match-end 0))
	  word))))

(defun unopify ()
  (save-excursion
    (beginning-of-buffer)
    (while (re-search-forward "[.]OP " (point-max) t)
      (goto-char (match-beginning 0))
      (delete-region (match-beginning 0) (match-end 0))
      (let* ((name (fetch-word))
	     (class (fetch-word))
	     (option (fetch-word))
	     (slot (fetch-word)))
	(insert "\n")
	(insert-command name class option slot)))))
		     
(defun insert-command (name class option slot)
  (insert (format "@deffn {Command-Line Name} %s\n" name))
  (insert (format "@deffnx {Class-field Name} %s\n" slot))
  (insert (format "@deffnx {Database Name} %s\n" option))
  (insert (format "@deffnx {Database Class} %s\n" class)))
  

(defun unshify ()
  (save-excursion
    (beginning-of-buffer)
    (while (re-search-forward (regexp-quote ".SH ") (point-max) t)
      (delete-region (match-beginning 0) (match-end 0))
      (let ((start (point)))
	(if (and (re-search-forward "\"\\([^\"\n]+\\)\"" (point-max) t)
		 (eq start (match-beginning 0)))
	    (let ((title (capitalize
			  (buffer-substring (match-beginning 1) (match-end 1)))))
	      (delete-region (match-beginning 0) (match-end 0))
	      (line-of-comment title)
	      (insert (format "@subsection %s\n" title)))
	  (if (and
	       (progn
		 (goto-char start)
		 (re-search-forward "[^\n]+" (point-max) t))
	       (eq start (match-beginning 0)))
	      (let ((title (capitalize
			    (buffer-substring (match-beginning 0) (match-end 0)))))
		(delete-region (match-beginning 0) (match-end 0))
		(line-of-comment title)
		(insert (format "@subsection %s\n" title)))))))))
	
  
(defun man->texinfo ()
  (interactive)
  (unopify)
  (save-excursion
    (beginning-of-buffer)
    (let ((case-replace t)
	  (case-fold-search t))
      (replace-string "\\fB" "@code{" nil)
      (beginning-of-buffer)
      (replace-string "\\fI" "@var{" nil)
      (beginning-of-buffer)
      (replace-string "\\fR" "}" nil)
      (beginning-of-buffer)
      (replace-string "stk" "biglook" nil)
      (beginning-of-buffer)
      (replace-string "tk" "biglook" nil)
      (beginning-of-buffer)
      (replace-string "Biglook_" "Tk_" nil)
      (beginning-of-buffer)
      (replace-string "BIglook" "Biglook" nil)
      (beginning-of-buffer)
      (replace-string "\\-" "-" nil)
      (beginning-of-buffer)
      (replace-string ".PP" "" nil)
      (beginning-of-buffer)
      (replace-string ".CS" "@smalllisp" nil)
      (beginning-of-buffer)
      (replace-string ".CE" "@end smalllisp" nil)
      (beginning-of-buffer)
      (replace-string ".RE" "@end table" nil)
      (beginning-of-buffer)
      (replace-string ".RS" "@table @code" nil)
      (beginning-of-buffer)
      (replace-string ".TP" "@item" nil)
      (beginning-of-buffer)
      (replace-string "..." "@dots{}" nil)
      (beginning-of-buffer)
      (replace-regexp ".IP [[][0-9]+[]]" "@item" nil)
      (beginning-of-buffer)
      (replace-string "procedure creates a new"
		      "class instantiation creates a new"
		      nil)
      (replace-string "'@code{" "'" nil)
      (unshify))))

      

