;*---------------------------------------------------------------------*/
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bglk/runtime/Llib/biglook.sch               */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Oct 20 13:06:41 1998                          */
;*    Last change :  Fri Apr  9 09:57:35 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The internal macros for the Biglook library                      */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    while ...                                                        */
;*---------------------------------------------------------------------*/
(define-macro (while test . body)
   (let ((while (gensym 'while))
	 (taux  (gensym 'test)))
      `(let ,while ((,taux ,test))
	    (if ,taux
		(begin ,@body (,while ,test))))))

;*---------------------------------------------------------------------*/
;*    unless ...                                                       */
;*---------------------------------------------------------------------*/
(define-macro (unless test . body)
   `(if (not ,test) (begin ,@body)))

;*---------------------------------------------------------------------*/
;*    when ...                                                         */
;*---------------------------------------------------------------------*/
(define-macro (when test . body)
   `(if ,test (begin ,@body)))

;*---------------------------------------------------------------------*/
;*    tk-get ...                                                       */
;*---------------------------------------------------------------------*/
(define-macro (tk-get w option)
  `(,w 'cget ,option))

;*---------------------------------------------------------------------*/
;*    tk-set! ...                                                      */
;*---------------------------------------------------------------------*/
(define-macro (tk-set! w option . value)
  `(,w 'configure ,option ,@value))

;*---------------------------------------------------------------------*/
;*    catch ...                                                        */
;*---------------------------------------------------------------------*/
(define-macro (catch . expr)
   `(try (begin ,@expr #f)
	 (lambda (escape _ _ _)
	    (escape #t))))
	    
;*---------------------------------------------------------------------*/
;*    tk ...                                                           */
;*---------------------------------------------------------------------*/
(define-expander tk
   (lambda (x e)
      (match-case x
	 ((?-)
	  '(tk))
	 ((?- ?o ?a1)
	  `(tk-1 ,(e o e) ,(e a1 e)))
	 ((?- ?o ?a1 ?a2)
	  `(tk-2 ,(e o e) ,(e a1 e) ,(e a2 e)))
	 ((?- ?o ?a1 ?a2 ?a3)
	  `(tk-3 ,(e o e) ,(e a1 e) ,(e a2 e) ,(e a3 e)))
	 ((?- ?o ?a1 ?a2 ?a3 ?a4)
	  `(tk-4 ,(e o e) ,(e a1 e) ,(e a2 e) ,(e a3 e) ,(e a4 e)))
	 ((?- . ?rest)
	  `(tk ,@(map (lambda (x) (e x e)) rest))))))
	 
		       
