;*---------------------------------------------------------------------*/
;*   This program is free software; you can redistribute it            */
;*   and/or modify it under the terms of the GNU General Public        */
;*   License as published by the Free Software Foundation; either      */
;*   version 2 of the License, or (at your option) any later version.  */
;*                                                                     */
;*   This program is distributed in the hope that it will be useful,   */
;*   but WITHOUT ANY WARRANTY; without even the implied warranty of    */
;*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     */
;*   GNU General Public License for more details.                      */
;*                                                                     */
;*   You should have received a copy of the GNU General Public         */
;*   License along with this program; if not, write to the Free        */
;*   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,   */
;*   MA 02111-1307, USA.                                               */
;*---------------------------------------------------------------------*/
;*=====================================================================*/
;*    serrano/prgm/project/bglk/runtime/Lwidget/text.scm               */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Oct 20 17:39:15 1998                          */
;*    Last change :  Wed Jun  9 13:48:15 1999 (serrano)                */
;*    -------------------------------------------------------------    */
;*    The text widget                                                  */
;*    -------------------------------------------------------------    */
;*    Source documentations:                                           */
;*       @path ../../manual/text.texi@                                 */
;*       @node Text@                                                   */
;*    Examples:                                                        */
;*       @path ../../demos/text/text.scm@                              */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __biglook_text

   (include "Llib/biglook.sch")

   (option  (loadq "Llib/biglook.init"))
   
   (import  (__biglook_glue  "Llib/scmglue.scm")
	    (__biglook_misc  "Llib/misc.scm")
	    (__biglook_focus "Llib/focus.scm")
	    (__biglook_tk-object "Llib/tk-object.scm"))

   (export  ;; tk text
            (class text::simple-widget
	       (text-init)
	       ;; items is the list of all the insets of a text (used by 
	       ;; tid->instance
	       (items (default '()))
	       ;; width
	       (width::int
		(get (lambda (o)
			(tk o 'cget :width)))
		(set (lambda (o v)
			(tk o 'configure :width v))))	     
	       ;; height
	       (height::int
		(get (lambda (o)
			(tk o 'cget :height)))
		(set (lambda (o v)
			(tk o 'configure :height v))))
	       ;; select-background
	       (select-background
		(get (lambda (o)
			(tk o 'cget :selectbackground)))
		(set (lambda (o v)
			(tk o 'configure :selectbackground v))))
	       ;; select-foreground
	       (select-foreground
		(get (lambda (o)
			(tk o 'cget :selectforeground)))
		(set (lambda (o v)
			(tk o 'configure :selectforeground v))))
	       ;; export-selection
	       (export-selection
		(get (lambda (o)
			(tk o 'cget :exportselection)))
		(set (lambda (o v)
			(tk o 'configure :exportselection v))))
	       ;; font
	       (font
		(get (lambda (o)
			(tk o 'cget :font)))
		(set (lambda (o v)
			(tk o 'configure :font v))))
	       ;; foreground
	       (foreground
		(get (lambda (o)
			(tk o 'cget :foreground)))
		(set (lambda (o v)
			(tk o 'configure :foreground v))))
	       ;; state
	       (state
		(get (lambda (o)
			(tk o 'cget :state)))
		(set (lambda (o v)
			(tk o 'configure :state v))))
	       ;; tabs
	       (tabs
		(get (lambda (o)
			(tk o 'cget :tabs)))
		(set (lambda (o v)
			(tk o 'configure :tabs v))))
	       ;; wrap
	       (wrap
		(get (lambda (o)
			(tk o 'cget :wrap)))
		(set (lambda (o v)
			(tk o 'configure :wrap v))))
	       ;; pad-x
	       (pad-x
		(get (lambda (o)
			(tk o 'cget :padx)))
		(set (lambda (o v)
			(tk o 'configure :padx v))))
	       ;; pad-y
	       (pad-y
		(get (lambda (o)
			(tk o 'cget :pady)))
		(set (lambda (o v)
			(tk o 'configure :pady v))))
	       ;; value
	       (value
		(get (lambda (o)
			(tk o 'get "1.0" 'end-1c)))
		(set (lambda (o v)
			(tk o 'delete "1.0" 'end)
			(tk o 'insert "1.0" v)))))

	    (class text-tag::tk-object
	       (text-tag-init)
	       (tid (default #unspecified))
	       (background
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :background)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :background v))))
	       (border-width
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :border-width)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :border-width v))))
	       (font
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :font)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :font v))))
	       (foreground
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :foreground)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :foreground v))))
	       (justify
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :justify)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :justify v))))
	       (lmargin1
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :lmargin1)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :lmargin1 v))))
	       (lmargin2
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :lmargin2)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :lmargin2 v))))
	       (relief
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :relief)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :relief v))))
	       (rmargin
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :rmargin)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :rmargin v))))
	       (tabs
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :tabs)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :tabs v))))
	       (underline
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :underline)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :underline v))))
	       (wrap
		(get (lambda (o)
		       (tk o 'tag 'cget (text-tag-tid o) :wrap)))
		(set (lambda (o v)
		       (tk o 'tag 'configure (text-tag-tid o) :wrap v)))))

	    text-init
	    text-tag-init
	    
	    (text-pos lig::int col::int)
	    (beginning-of-line t::text line::int)
	    (end-of-line t::text line::int)
	    (beginning-of-buffer t::text)  ; for symetry only
	    (end-of-buffer t::text)

	    (text-delete t::text pos1 . pos2)
	    (text-chars t::text pos1 . pos2)
	    (text-line t::text line)
	    (text-insert t::text txt::bstring pos)
	    (text-see-pos t::text pos)
	    add-text-tag))

;*---------------------------------------------------------------------*/
;*    text-init ...                                                    */
;*---------------------------------------------------------------------*/
(define text-init
   (let ((text (make-widget-constructor "text")))
      (lambda (o) (simple-widget-init o text))))


;*---------------------------------------------------------------------*/
;*    text-tag-init ...                                                */
;*---------------------------------------------------------------------*/
(define (text-tag-init self::text-tag)
  (with-access::text-tag self (id eid tid parent)
      (if (not (text? parent))
	  (error "text-tag-init" "Parent is not a text" parent)
	  (begin
	     (set! id  (text-id parent))
	     (set! eid (text-id parent))
	     (set! tid (gensym "tag_"))

	     ;; tk <-> biglook connection
	     (tk-command-object-set! eid self)
	     
	     ;; Create the tag (configuring it suffice to create it)
	     (tk parent 'tag 'configure Tid)
	     
	     (with-access::text parent (items)
	       (set! items (cons (cons tid self) items)))))))

;*---------------------------------------------------------------------*/
;*    tid->instance ...                                                */
;*---------------------------------------------------------------------*/
(define (tid->instance self::text id)
   (with-access::text self (items)
      (let ((cell (assq id items)))
	 (if (pair? cell)
	     (cdr cell)
	     #f))))

;*---------------------------------------------------------------------*/
;*    Global parameters                                                */
;*---------------------------------------------------------------------*/
(define press-x     0)
(define press-y     0)
(define relief      "sunken")
(define mouse-moved #f)
(define select-mode "char")

;*---------------------------------------------------------------------*/
;*    format@, ...                                                     */
;*---------------------------------------------------------------------*/
(define (format@, x y)
   (let ((port (open-output-string)))
      (display "@" port)
      (display x port)
      (display "," port)
      (display y port)
      (close-output-port port)))

;*---------------------------------------------------------------------*/
;*    format~A ...                                                     */
;*---------------------------------------------------------------------*/
(define (format~A string obj)
   (let ((port (open-output-string)))
      (display obj port)
      (display " " port)
      (display string port)
      (close-output-port port)))

;*---------------------------------------------------------------------*/
;*    text widget ...                                                  */
;*---------------------------------------------------------------------*/

;; text-button-1 --
;; This procedure is invoked to handle button-1 presses in "Text"
;; widgets.  It moves the insertion cursor, sets the selection anchor,
;; and claims the input focus.
;;
;; w -		The "Text" windselectow in which the button was pressed.
;; x -		The x-coordinate of the button press.
;; y -		The x-coordinate of the button press.

(define (text-button-1 w x y)
  (set! select-mode "char")
  (set! mouse-moved #f)
  (set! press-x x)
  (set! press-y y)
  (w 'mark 'set 'insert (text-closest-gap w x y))
  (w 'mark 'set 'anchor "insert")
  (if (equal? (tk-get w :state) "normal")
      (focus w)))

;; text-select-to --
;; This procedure is invoked to extend the selection, typically when
;; dragging it with the mouse.  Depending on the selection mode (character,
;; word, line) it selects in different-sized units.  This procedure
;; ignores mouse motions initially until the mouse has moved from
;; one character to another or until there have been multiple clicks.
;;
;; w -		The text window in which the button was pressed.
;; x -		Mouse x position.
;; y - 		Mouse y position.

(define (text-select-to w x y)
  (let ((cur    (text-closest-gap w x y))
	(first  #f)
	(last   #f)
	(anchor #f))

    (if (catch (w 'index 'anchor))
	(w 'mark 'set 'anchor cur))
    (set! anchor (w 'index 'anchor))

    (if (or (w 'compare cur "!=" anchor)
	    (>= (abs (- press-x x)) 3))
	(set! mouse-moved #t))

    (cond
      ((string=? select-mode "char")
               (if (w 'compare cur "<" "anchor")
		   (begin
		     (set! first cur)
		     (set! last "anchor"))
		   (begin
		     (set! first "anchor")
		     (set! last cur))))
      ((string=? select-mode "word")
                (if (w 'compare cur "<" "anchor")
		   (begin
		     (set! first (w 'index (format~A "wordstart" cur)))
		     (set! last  (w 'index "anchor - 1c wordend")))
		   (begin
		     (set! first (w 'index "anchor wordstart"))
		     (set! last  (w 'index (format~A "-1c wordend" cur))))))
      ((string=? select-mode "line")
	        (if (w 'compare cur "<" "anchor")
		    (begin
		      (set! first (w 'index (format~A "linestart" cur)))
		      (set! last  (w 'index "anchor - 1c lineend + 1c")))
		    (begin
		      (set! first (w 'index "anchor linestart"))
		      (set! last  (w 'index (format~A "lineend + 1c" cur)))))))
     
    (when (or mouse-moved (not (equal? select-mode "char")))
        (w 'mark 'set 'insert last)
	(w 'tag 'remove "sel" "0.0" first)
	(w 'tag 'add "sel" first last)
	(w 'tag 'remove "sel" last "end")
	(update 'idletasks))))

;; text-key-extend --
;; This procedure handles extending the selection from the keyboard,
;; where the point to extend to is really the boundary between two
;; characters rather than a particular character.
;;
;; w -		The text window.
;; index -	The point to which the selection is to be extended.

(define (text-key-extend w index)
  (let ((cur    (w 'index index))
	(anchor #f))
    
    (if (catch (w 'index 'anchor))
	(w 'mark 'set 'anchor cur))
    (set! anchor (w 'index 'anchor))

    (let ((first #f)
	  (last #f))
      (if (w 'compare cur "<" anchor)
	  (begin
	    (set! first cur)
	    (set! last anchor))
	  (begin
	    (set! first anchor)
	    (set! last cur)))
      
      (w 'tag 'remove "sel" "0.0" first)
      (w 'tag 'add "sel" first last)
      (w 'tag 'remove "sel" last "end"))))


;; text-auto-scan --
;; This procedure is invoked when the mouse leaves an "Text" window
;; with button 1 down.  It scrolls the window left or right,
;; depending on where the mouse is, and reschedules itself as an
;; "after" command so that the window continues to scroll until the
;; mouse moves back into the window or the mouse button is released.
;;
;; w -	The "Text" window.

(define (text-auto-scan w)
  (when (winfo 'exists w)
    (let* ((x    *x*)
	   (y    *y*)
	   (cont (lambda () 
		   (text-select-to w x y)
		   (set! *after-id* (after 50 (lambda () 
						 (text-auto-scan w)))))))
      (cond 
       ((>= y (winfo 'height w))	(w 'yview 'scroll +2 'units) (cont))
       ((< y 0)				(w 'yview 'scroll -2 'units) (cont))
       ((>= x (winfo 'width w))		(w 'xview 'scroll +2 'units) (cont))
       ((< x 0)				(w 'xview 'scroll -2 'units) (cont))))))


;; text-set-cursor
;; Move the insertion cursor to a given position in a text.  Also
;; clears the selection, if there is one in the text, and makes sure
;; that the insertion cursor is visible.  Also, don't let the insertion
;; cursor appear on the dummy last line of the text.
;;
;; w -		The text window.
;; pos -		The desired new position for the cursor in the window.

(define (text-set-cursor w pos)
  (if (w 'compare pos "==" "end")
      (set! pos "end - 1 chars"))

  (w 'mark 'set 'insert pos)
  (w 'tag 'remove 'sel "1.0" "end")
  (w 'see "insert"))


;; text-key-select --
;; This procedure is invoked when stroking out selections using the
;; keyboard.  It moves the cursor to a new position, then extends
;; the selection to that position.
;;
;; Arguments:
;; w -		The "Text" window.
;; new -	A new position for the insertion cursor (the cursor hasn't
;;		actually been moved to this position yet).

(define (text-key-select w new)
  (if (equal? (w 'tag 'nextrange "sel" "1.0" "end") "")
      (begin
	(if (w 'compare new "<" "insert")
	    (w 'tag 'add "sel" new "insert")
	    (w 'tag 'add "sel" "insert" new))
	(w 'mark 'set 'anchor "insert"))
      (let ((first #f)
	    (last  #f))
	(if (w 'compare new "<" 'anchor)
	    (begin
	      (set! first new)
	      (set! last "anchor"))
	    (begin
	      (set! first "anchor")
	      (set! last new)))
	(w 'tag 'remove "sel" "1.0" first)
	(w 'tag 'add "sel" first last)
	(w 'tag 'remove "sel" last "end")))

  (w 'mark 'set "insert" new)
  (w 'see "insert")
  (update 'idletasks))


;; text-reset-anchor --
;; Set the selection anchor to whichever end is farthest from the
;; index argument.  One special trick: if the selection has two or
;; fewer characters, just leave the anchor where it is.  In this
;; case it doesn't matter which point gets chosen for the anchor,
;; and for the things like Shift-Left and Shift-Right this produces
;; better behavior when the cursor moves back and forth across the
;; anchor.
;;
;; w -		The text widget.
;; index -	Position at which mouse button was pressed, which determines
;;		which end of selection should be used as anchor point.

(define (text-reset-anchor w index)
  (if (null? (w 'tag 'ranges "sel"))
      (w 'mark 'set 'anchor index)
      (let ((a 	(w 'index index))
	    (b 	(w 'index 'sel.first))
	    (c 	(w 'index 'sel.last)))

	(if (w 'compare a "<" b)
	    (w 'mark 'set 'anchor 'sel.first)
	    (if (w 'compare a ">" c)
		(w 'mark 'set 'anchor 'sel.first)
		(if (< (car b) (+ (car c) 2))
		    (let ((total (string-length (w 'get b c))))
		      (when (> total 2)
			    (w 'mark 
			       'set 
			       'anchor 
			       (if (< (string-length (w 'get b c)) (/ total 2))
				   'sel.last
				   'sel.first))))
		    (w 'mark 
		       'set 
		       'anchor
		       (if (< (- (car a) (car b))
			      (- (car c) (car a)))
			   'sel.last
			   'sel.first))))))))

;; text-ins --
;; Insert a string into an "Text" at the point of the insertion cursor.
;; If there is a selection in the "Text", and it covers the point of the
;; insertion cursor, then delete the selection before inserting.
;;
;; w -		The "Text" window in which to insert the string
;; s -		The string to insert (usually just a single character)

(define (text-ins w s)
  (unless (or (equal? s "") (equal? (tk-get w :state) "disabled"))
     (catch
        (if (and (w 'compare 'sel.first "<=" "insert")
		 (w 'compare 'sel.last ">="  "insert"))
	    (w 'delete 'sel.first 'sel.last)))
     (w 'insert "insert" s)
     (w 'see "insert")))

;; text-up-down-line --
;; Returns the index of the character one line above or below the
;; insertion cursor.  There are two tricky things here.  First,
;; we want to maintain the original column across repeated operations,
;; even though some lines that will get passed through don't have
;; enough characters to cover the original column.  Second, don't
;; try to scroll past the beginning or end of the text.
;;
;; w -		The text window in which the cursor is to move.
;; n -		The number of lines to move: -1 for up one line,
;;		+1 for down one line.

(define text-up-down-line 
  (let ((column 0)
	(prev-pos (list -1 -1)))
    (lambda (w n)
      (let ((p (w 'index "insert")))
	
	(unless (equal? prev-pos p)
		(set! column (cadr p)))

	(let ((new (w 'index (list (+ (car p) n) column))))
	  (if (or (w 'compare new "==" "end")
		  (w 'compare new "==" "insert linestart"))
	      (set! new p))
	  
	  (set! prev-pos new)
	  new)))))

;; text-scroll-pages --
;; This is a utility procedure used in bindings for moving up and down
;; pages and possibly extending the selection along the way.  It scrolls
;; the view in the widget by the number of pages, and it returns the
;; index of the character that is at the same position in the new view
;; as the insertion cursor used to be in the old view.
;;
;; w -		The text window in which the cursor is to move.
;; count -	Number of pages forward to scroll;  may be negative
;;		to scroll backwards.

(define (text-scroll-pages w count)
  (let ((bbox (w 'bbox "insert")))
    (w 'yview 'scroll count 'pages)
    (w 'index (if (null? bbox)
		  (format@, (truncate (/ (winfo 'height w) 2)) 0)
		  (format@, (car bbox) (cadr bbox))))))


;; text-transpose --
;; This procedure implements the "transpose" function for text widgets.
;; It tranposes the characters on either side of the insertion cursor,
;; unless the cursor is at the end of the line.  In this case it
;; transposes the two characters to the left of the cursor.  In either
;; case, the cursor ends up to the right of the transposed characters.
;;
;; Arguments:
;; w -		Text window in which to transpose.

(define (text-transpose w)
  (let* ((pos (if (w 'compare "insert" "!=" "insert lineend")
		  "insert + 1 char"
		  "insert"))
	 (new (string-append (w 'get (format~A "- 1 char" pos))
			     (w 'get (format~A "- 2 char" pos)))))

    (when (w 'compare (format~A "- 1 char" pos) "!=" "1.0")
       (w 'delete (format~A "- 2 char" pos) pos)
       (w 'insert "insert" new)
       (w 'see "insert"))))


;; text-closest-gap --
;; Given x and y coordinates, this procedure finds the closest boundary
;; between characters to the given coordinates and returns the index
;; of the character just after the boundary.
;;
;; w -		The text window.
;; x -		X-coordinate within the window.
;; y -		Y-coordinate within the window.

(define (text-closest-gap w x y)
  (let* ((pos  (w 'index (format@, x y)))
	 (bbox (w 'bbox  pos)))
    (if (null? bbox)
	(if (< [list-ref bbox 0] (/ [list-ref bbox 2] 2))
	    pos
	    (w 'index (format~A "+ 1 char" pos)))
	pos)))

;; text-mouse-paste --
;; This procedure sets the insertion cursor to the mouse position,
;; inserts the selection, and sets the focus to the window.
;;
;; w -		The text window.
;; x, y - 	Position of the mouse.

(define (text-mouse-paste WW x y)
  (WW 'mark 'set 'insert (text-closest-gap WW x y))
  (catch (WW 'insert 'insert (selection 'get :displayof WW)))
  (if (string=? (tk-get WW :state) "normal")
      (focus WW)))


;; text-copy --
;; This procedure copies the selection from a text widget into the clipboard.
;;
;; w -		Name of a text widget.

(define (text-copy w)
  (clipboard 'clear :displayof w)
  (catch 
     (clipboard 'append :displayof w (w 'get 'sel.first 'sel.last))))

;; text-cut --
;; This procedure copies the selection from a text widget into the
;; clipboard, then deletes the selection (if it exists in the given
;; widget).
;;
;;  w -		Name of a text widget.

(define (text-cut w)
  (when (equal? [selection 'own :displayof w] w)
       (clipboard 'clear :displayof w)
       (catch
	  (clipboard 'append :displayof w (selection 'get :displayof w))
	  (w 'delete 'sel.first 'sel.last))))

;; text-paste --
;; This procedure pastes the contents of the clipboard to the insertion
;; point in a text widget.
;;
;; w -		Name of a text widget.

(define (text-paste w)
  (catch 
     (w 'insert 'insert (selection 'get :displayof w :selection "CLIPBOARD"))))

;;-------------------------------------------------------------------------
;; The code below creates the default class bindings for entries.
;;-------------------------------------------------------------------------

;; Standard Motif bindings:

(add-binding! "Text" "<1>" (WW x y)
  (text-button-1 WW x y)
  (WW 'tag 'remove "sel" "0.0" "end"))

(add-binding! "Text" "<B1-Motion>" (WW x y)
  (set! *x* x)
  (set! *y* y)
  (text-select-to WW x y))

(add-binding! "Text" "<Double-1>" (WW x y)
  (set! select-mode "word")
  (text-select-to WW x y)
  (catch 
     (WW 'mark 'set "insert" 'sel.first)))

(add-binding! "Text" "<Triple-1>" (WW x y)
  (set! select-mode "line")
  (text-select-to WW x y)
  (catch 
      (WW 'mark 'set "insert" 'sel.first)))

(add-binding! "Text" "<Shift-1>" (WW x y)
  (text-reset-anchor WW (format@, x y))
  (set! select-mode "char")
  (text-select-to WW x y))

(add-binding! "Text" "<Double-Shift-1>" (WW x y)
  (set! select-mode "word")
  (text-select-to WW x y))

(add-binding! "Text" "<Triple-Shift-1>" (WW x y)
  (set! select-mode "line")
  (text-select-to WW x y))

(add-binding! "Text" "<B1-Leave>" (WW x y)
  (set! *x* x)
  (set! *y* y)
  (text-auto-scan WW))

(add-binding! "Text" "<B1-Enter>" ()
  (cancel-repeat))

(add-binding! "Text" "<ButtonRelease-1>" ()
  (cancel-repeat))

(add-binding! "Text" "<Control-1>" (WW x y)
  (WW 'mark 'set "insert" (format@, x y)))

(add-binding! "Text" "<Left>" (WW)
  (text-set-cursor WW "insert-1c"))

(add-binding! "Text" "<Right>" (WW)
  (text-set-cursor WW "insert+1c"))

(add-binding! "Text" "<Up>" (WW)
  (text-set-cursor WW (text-up-down-line WW -1)))

(add-binding! "Text" "<Down>" (WW)
  (text-set-cursor WW (text-up-down-line WW +1)))

(add-binding! "Text" "<Shift-Left>" (WW)
  (text-key-select WW (WW 'index "insert-1c")))

(add-binding! "Text" "<Shift-Right>" (WW)
  (text-key-select WW (WW 'index "insert+1c")))

(add-binding! "Text" "<Shift-Up>" (WW)
  (text-key-select WW (text-up-down-line WW -1)))

(add-binding! "Text" "<Shift-Down>" (WW)
  (text-key-select WW (text-up-down-line WW +1)))

(add-binding! "Text" "<Control-Left>" (WW)
  (text-set-cursor WW (WW 'index "insert-1c wordstart")))

(add-binding! "Text" "<Control-Right>" (WW)
  (text-set-cursor WW (WW 'index "insert wordend")))

(add-binding! "Text" "<Shift-Control-Left>" (WW)
  (text-key-select WW  (WW 'index "insert-1c  wordstart")))

(add-binding! "Text" "<Shift-Control-Right>" (WW)
  (text-key-select WW (WW 'index "insert wordend")))

(add-binding! "Text" "<Prior>" (WW)
  (text-set-cursor WW (text-scroll-pages WW -1)))

(add-binding! "Text" "<Shift-Prior>" (WW)
  (text-key-select WW (text-scroll-pages WW -1)))

(add-binding! "Text" "<Next>" (WW)
  (text-set-cursor WW (text-scroll-pages WW +1)))

(add-binding! "Text" "<Shift-Next>" (WW)
  (text-key-select WW (text-scroll-pages WW +1)))

(add-binding! "Text" "<Control-Prior>" (WW)
  (WW 'xview 'scroll -1 'page))

(add-binding! "Text" "<Control-Next>" (WW)
  (WW 'xview 'scroll 1 'page))

(add-binding! "Text" "<Home>" (WW)
  (text-set-cursor WW "insert linestart"))

(add-binding! "Text" "<Shift-Home>" (WW)
  (text-set-cursor WW "insert linestart"))

(add-binding! "Text" "<End>" (WW)
  (text-set-cursor WW "insert lineend"))

(add-binding! "Text" "<Shift-End>" (WW)
  (text-set-cursor WW "insert lineend"))

(add-binding! "Text" "<Control-Home>" (WW)
  (text-set-cursor WW "1.0"))

(add-binding! "Text" "<Control-Shift-Home>" (WW)
  (text-key-select WW "1.0"))

(add-binding! "Text" "<Control-End>" (WW)
  (text-set-cursor WW "end - 1 char"))

(add-binding! "Text" "<Control-Shift-End>" (WW)
  (text-key-select WW "end - 1 char"))

(add-binding! "Text" "<Tab>" (WW)
  (text-ins WW #"\t")
  (focus WW)
  'break)

(add-binding! "Text" "<Shift-Tab>" (WW)
  ;; Needed only to keep <Tab> binding from triggering;  doesn't
  ;; have to actually do anything.
  'break)

(add-binding! "Text" "<Control-Tab>" (WW)
  (focus (focus-next WW)))

(add-binding! "Text" "<Control-Shift-Tab>" (WW)
  (focus (focus-prev WW)))

(add-binding! "Text" "<Control-i>" (WW)
  (text-ins WW #"\t"))

(add-binding! "Text" "<Return>" (WW)
  (text-ins WW #"\n"))

(add-binding! "Text" "<Delete>" (WW)
  (if (null? (WW 'tag 'nextrange 'sel "1.0" "end"))
      (begin 
	 (WW 'delete "insert")
	 (WW 'see "insert"))
      (WW 'delete 'sel.first 'sel.last)))

(add-binding! "Text" "<BackSpace>" (WW)
  (if (null? (WW 'tag 'nextrange 'sel "1.0" "end"))
      (begin 
	 (WW 'delete "insert-1c")
	 (WW 'see "insert"))
      (WW 'delete 'sel.first 'sel.last)))

(add-binding! "Text" "<Control-space>" (WW)
  (WW 'mark 'set 'anchor "insert"))

(add-binding! "Text" "<Select>" (WW)
 (WW 'mark 'set 'anchor "insert"))

(add-binding! "Text" "<Control-Shift-space>" (WW)
  (set! select-mode "char")
  (text-key-extend WW "insert"))

(add-binding! "Text" "<Shift-Select>" (WW)
  (set! select-mode "char")
  (text-key-extend WW "insert"))

(add-binding! "Text" "<Control-slash>" (WW)
  (WW 'tag 'add 'sel "1.0" "end"))

(add-binding! "Text" "<Control-backslash>" (WW)
  (WW 'tag 'remove 'sel "1.0" "end"))

(add-binding! "Text" "<<Cut>>" (WW)
  (text-cut WW))

(add-binding! "Text" "<<Copy>>" (WW)
  (text-copy WW))

(add-binding! "Text" "<<Paste>>" (WW)
  (text-paste WW))

(add-binding! "Text" "<<Clear>>" (WW)
  (catch (WW 'delete 'sel.first 'sel.last)))

(add-binding! "Text" "<<PasteSelection>>" (WW x y)
  (if (or (not mouse-moved) *tk-strict-motif*)
      (text-mouse-paste WW x y)))

(add-binding! "Text" "<Insert>" (WW)
  (catch 
     (text-ins WW (selection 'get :displayof WW))))

(add-binding! "Text" "<KeyPress>" (WW AA)
  (text-ins WW AA))


;; Ignore all Alt, Meta, and Control keypresses unless explicitly bound.
;; Otherwise, if a widget binding for one of these is defined, the
;; <KeyPress> class binding will also fire and insert the character,
;; which is wrong.  Ditto for Escape.
(add-binding! "Text" "<Alt-KeyPress>" () 'nop)
(add-binding! "Text" "<Meta-KeyPress>" () 'nop)
(add-binding! "Text" "<Control-KeyPress>" () 'nop)
(add-binding! "Text" "<Escape>" () 'nop)
(add-binding! "Text" "<KP_Enter>" () 'nop)

;; Additional emacs-like bindings:

(add-binding! "Text" "<Control-a>" (WW)
  (text-set-cursor WW "insert linestart"))

(add-binding! "Text" "<Control-b>" (WW)
  (text-set-cursor WW "insert-1c"))

(add-binding! "Text" "<Control-d>" (WW)
  (WW 'delete "insert"))

(add-binding! "Text" "<Control-e>" (WW)
  (text-set-cursor WW "insert lineend"))

(add-binding! "Text" "<Control-f>" (WW)
  (text-set-cursor WW "insert+1c"))

(add-binding! "Text" "<Control-k>" (WW)
  (WW 'delete "insert" (if (WW 'compare "insert" "==" "insert lineend")
			   "insert+1c"
			   "insert lineend")))

(add-binding! "Text" "<Control-n>" (WW)
  (text-set-cursor WW (text-up-down-line WW +1)))

(add-binding! "Text" "<Control-o>" (WW)
  (WW 'insert "insert" #"\n")
  (WW 'mark 'set "insert" "insert-1c"))

(add-binding! "Text" "<Control-p>" (WW)
  (text-set-cursor WW (text-up-down-line WW -1)))

(add-binding! "Text" "<Control-t>" (WW)
  (text-transpose WW))

(add-binding! "Text" "<Control-v>" (WW)
  (text-scroll-pages WW +1))

(add-binding! "Text" "<Meta-b>" (WW)
  (text-set-cursor WW "insert - 1c wordstart"))

(add-binding! "Text" "<Meta-d>" (WW)
  (WW 'delete "insert" "insert wordend"))

(add-binding! "Text" "<Meta-f>" (WW)
  (text-set-cursor WW "insert wordend"))

(add-binding! "Text" "<Meta-less>" (WW)
  (text-set-cursor WW "1.0"))

(add-binding! "Text" "<Meta-greater>" (WW)
  (text-set-cursor WW "end-1c"))

(add-binding! "Text" "<Meta-BackSpace>" (WW)
  (WW 'delete "insert -1c wordstart" "insert"))

(add-binding! "Text" "<Meta-Delete>" (WW)
  (WW 'delete "insert -1c wordstart" "insert"))

;; A few additional bindings of my own.

(add-binding! "Text" "<Control-h>" (WW)
  (when (WW 'compare "insert" "!=" "1.0")
    (WW 'delete "insert-1c")
    (WW 'see "insert")))

(add-binding! "Text" "<Shift-2>" (WW x y)
  (WW 'scan 'mark x y)
  (set! *x* x)
  (set! *y* y)
  (set! mouse-moved #f))

(add-binding! "Text" "<Shift-B2-Motion>" (WW x y)
  (unless (and  (= x *x*) (= y *y*))
    (set! mouse-moved #t))
  (if mouse-moved
      (WW 'scan 'dragto x y)))


;=============================================================================


;*---------------------------------------------------------------------*/
;*    text-pos ...                                                     */
;*---------------------------------------------------------------------*/
(define (text-pos lig col)
  (list lig col))

;*---------------------------------------------------------------------*/
;*    beginning-of-line ...                                            */
;*---------------------------------------------------------------------*/
(define (beginning-of-line t::text line::int)
  (text-pos line 0))

;*---------------------------------------------------------------------*/
;*    end-of-line ...                                                  */
;*---------------------------------------------------------------------*/
(define (end-of-line t::text line::int)
  (tk t 'index (let ((port (open-output-string)))
		 (display line port)
		 (display ".0 lineend" port)
		 (close-output-port port))))

;*---------------------------------------------------------------------*/
;*    beginning-of-buffer ...                                          */
;*---------------------------------------------------------------------*/
(define (beginning-of-buffer t::text)	; really useless 
  (text-pos 1 0))


;*---------------------------------------------------------------------*/
;*    end-of-buffer ...                                                */
;*---------------------------------------------------------------------*/
(define (end-of-buffer t::text)
  (tk t 'index "end"))


;=============================================================================

;*---------------------------------------------------------------------*/
;*    text-delete ...                                                  */
;*---------------------------------------------------------------------*/
(define (text-delete t::text pos1 . pos2)
  (apply tk t 'delete pos1 pos2))

;*---------------------------------------------------------------------*/
;*    text-chars ...                                                   */
;*---------------------------------------------------------------------*/
(define (text-chars t::text pos1 . pos2)
  (apply tk t 'get pos1 pos2))

;*---------------------------------------------------------------------*/
;*    text-line ...                                                    */
;*---------------------------------------------------------------------*/
(define (text-line t::text line)
  (tk t 'get (beginning-of-line t line) (end-of-line t line)))


;*---------------------------------------------------------------------*/
;*    text-insert ...                                                  */
;*---------------------------------------------------------------------*/
(define (text-insert t::text txt::bstring pos)
  (tk t 'insert pos txt))

;; SEARCH???

;*---------------------------------------------------------------------*/
;*    text-see-pos ...                                                 */
;*---------------------------------------------------------------------*/
(define (text-see-pos t::text pos)
  (tk t 'see pos))


;*---------------------------------------------------------------------*/
;*    add-text-tag ...                                                 */
;*---------------------------------------------------------------------*/
(define (add-text-tag self::text-tag start-pos stop-pos)
  (tk self 'tag 'add (text-tag-tid self) start-pos stop-pos))

;*---------------------------------------------------------------------*/
;*    tag-bind ::text ...                                              */
;*---------------------------------------------------------------------*/
(define-method (tag-bind obj::text key::bstring . args)
   (apply tk obj 'tag 'bind key args))
   
